(function ($) {
	"use strict";

	$(document).on(
		"click",
		".wopb-wishlist-add, .wopb-wishlist-remove, .wopb-wishlist-cart-added",
		function (e) {
			e.preventDefault();
			const that = $(this);
			const _modal = $('.wopb-modal-wrap');
			const actionType = that.data("action");

			if (
				actionType == "remove" ||
				actionType == "cart_remove" ||
				actionType == "cart_remove_all"
			) {
				if (that.closest('tbody').find('tr').length <= 1) {
					that.closest("table").remove();
					_modal.removeClass('active');
				} else {
					that.closest("tr").remove();
				}
			}


			$.ajax({
				url: wopb_data.ajax,
				type: "POST",
				data: {
					action: "wopb_wishlist",
					post_id: that.data("postid"),
					type: actionType,
					wpnonce: wopb_data.security,
				},
				beforeSend: function () {
					if (that.data("redirect") == undefined && actionType == 'add') {
						_modal.find('.wopb-modal-body').html('');
						_modal.addClass('active');
						_modal.find('.wopb-modal-loading').addClass('active');
					}
				},
				success: function (response) {
					if (response.success) {
						if (actionType == "add") {
							_modal.find('.wopb-modal-body').html(response.data.html);
							that.addClass('wopb-wishlist-active');
						}
						const redirectUrl = that.data("redirect");
						if (redirectUrl) {
							window.location.href = redirectUrl;
						}
					}
				},
				complete: function (data) {
					_modal.find('.wopb-modal-loading').removeClass('active');
				},
				error: function (xhr) {
					console.log( "Error occured.please try again" + xhr.statusText + xhr.responseText );
				},
			});
		}
	);


	// ------------------------
    // Wishlist Modal Close
    // ------------------------
	$(document).on('click', '.wopb-modal-close, .wopb-modal-continue', function(e){ // Close Button
		e.preventDefault();
        $(this).closest('.wopb-modal-wrap').removeClass('active');
    });
    document.addEventListener('keydown', function(e) { // ESC Keydown Close
        if(e.keyCode === 27){
            $('.wopb-modal-wrap').removeClass('active');
        }
	});
	$(document).on( 'click', '.wopb-modal-wrap', function (e) { // Outside Click
		e.preventDefault();
        if (
			!$(e.target).hasClass('wopb-wishlist-remove') && 
			$(e.target).parents('.wopb-modal-body').length === 0 && 
			$(e.target).parents('.wopb-quick-view-navigation').length === 0 ) {
            	$('.wopb-modal-wrap').removeClass('active');
        }
    });

})(jQuery);