<?php
namespace WOPB;

defined('ABSPATH') || exit;

class Options_Addons{
    public function __construct() {
        add_submenu_page('wopb-settings', 'Addons', 'Addons', 'manage_options', 'wopb-addons', array( $this, 'create_admin_page'), 10);
    }

    public static function all_addons(){
        $all_addons = array(
            // 'wopb_image_flip' => array(
            //     'name' => __( 'Image Flip', 'product-blocks' ),
            //     'desc' => __( 'Add Image Flip Option for Blocks.', 'product-blocks' ),
            //     'img' => WOPB_URL.'/assets/img/addons/image-flip.svg',
            //     'is_pro' => false
            // )
        );
        return apply_filters('wopb_addons_config', $all_addons);
    }

    /**
     * Settings page output
     */
    public function create_admin_page() { ?>
        <style>
            .style-css{
                background-color: #f2f2f2;
                -webkit-font-smoothing: subpixel-antialiased;
            }
        </style>

        <div class="wopb-option-body">
            
            <?php require_once WOPB_PATH . 'classes/options/Heading.php'; ?>

            <div class="wopb-content-wrap wopb-addons-wrap">
                <h2 class="wopb-settings-heading"><?php _e('All Addons', 'product-blocks'); ?></h2>
                <div class="wopb-addons-items">
                    <?php
                        $option_value = wopb_function()->get_setting();
                        $addons_data = self::all_addons();
                        foreach ($addons_data as $key => $val) {
                            echo '<div class="wopb-addons-item wopb-admin-card">';
                                echo '<div class="wopb-addons-item-content">';
                                    echo '<img src="'.$val['img'].'" />';
                                    echo '<h4>'.$val['name'].'</h4>';
                                    echo '<div class="wopb-addons-desc">'.$val['desc'].'</div>';
                                echo '</div>';
                            if( $val['is_pro'] && !defined('WOPB_PRO_VER') ){
                                echo '<div class="wopb-addons-btn">';
                                    echo '<a class="wopb-btn wopb-btn-default" target="_blank" href="'.wopb_function()->get_premium_link().'">'.__("Get Pro", "product-blocks").'</a>';
                                echo '</div>';
                                
                            } else {
                                echo '<div class="wopb-addons-btn">';
                                    echo '<label class="wopb-switch">';
                                        echo '<input class="wopb-addons-enable" '.(($val['is_pro'] && (!defined('WOPB_PRO_VER'))) ? 'disabled' : '').' data-addon="'.$key.'" type="checkbox" '.( isset($option_value[$key]) && $option_value[$key] == 'true' ? 'checked' : '' ).'>';
                                        echo '<span class="wopb-slider wopb-round"></span>';
                                    echo '</label>';
                                echo '</div>';
                            }
                            echo '</div>';
                        }
                    ?> 
                </div>
            </div>
        </div>

    <?php }
}